
package ev.cc;

import ev.Geno;
import ev.Pheno;
import ev.PopulationFunction;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;


/**
 *
 * @author sigved
 */
public class ChildCreator extends PopulationFunction<Pheno> {
    private ParentSelector selector;
    public int numberOfChildren = 0;
    public int numberOfParents = 0;
    public double mutationRate = 0.0d;
    public double crosschance = 0.0d;
    List<GenoFunction> genoFunctions = new ArrayList<GenoFunction>();
    public ParentSelector getParentSelector(){
        return selector;
    }
    public void setSelector(ParentSelector ps){
        this.selector = ps;
    }
    public void setNumberOf(int numberof){
        this.numberOfChildren = numberof;
    }
    public void setNumberOfParents(int np){
        this.numberOfParents = np;
    }
    @Override
    public Set<Pheno> runOnPopulation(Set<Pheno> pop) {
        for(int i = 0; i < numberOfChildren; i++){
            List<Pheno> set = selector.selectParents(numberOfParents, pop, crosschance);
            Geno base = set.remove(0).getGeno();
            Geno[] otherGeno = new Geno[set.size()];
            for(int n = 0; n < set.size(); n++){
                otherGeno[n] = set.get(n).getGeno();
            }
            Geno ngeno = base.combineWith(otherGeno);
            for(GenoFunction gf : genoFunctions)ngeno = gf.useOn(ngeno);
            ngeno.mutate(mutationRate);
            pop.add(ngeno.createPheno());
        }
        return pop;
    }
    
}
