
package ev.popfunc;

import ev.Pheno;
import ev.PopulationFunction;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;

/**
 *
 * @author sigved
 */
public class PopulationLimit extends PopulationFunction<Pheno> {
    public int limit = 1000000000;
    public double maxAge = -1;
    public double minAge = -1;

    @Override
    public Set<Pheno> runOnPopulation(Set<Pheno> pop) {
        Set<Pheno> np = new HashSet<Pheno>();
        TreeSet<Pheno> ts = new TreeSet<Pheno>(new Comparator<Pheno>(){
            @Override
            public int compare(Pheno arg0, Pheno arg1) {
                if(arg0.getFitness() >= arg1.getFitness())return 1;
                else return -1;
            }
            
        });
        for(Pheno p : pop){
            if(p.getAge() < maxAge && p.getAge() > minAge){
                ts.add(p);
            }else{
                np.add(p);
            }
        }
        Iterator<Pheno> itr = ts.descendingIterator();
        for(int i = 0; i < limit && itr.hasNext(); i++)np.add(itr.next());
        return np;
    }
    
}
