
package ev.ui;

import ev.Evolution;
import ev.cc.ChildCreator;
import ev.cc.ParentSelector;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JButton;
import javax.swing.JOptionPane;

/**
 *
 * @author sigved
 */
class ChildCreatorPanel extends GenericFunctionPanel{
    private final Evolution ev;
    private final ChildCreator cc;
    private ParentSelectorPane psp;
    private JButton ps;

    public ChildCreatorPanel(ChildCreator childCreator, Evolution ev) {
        super(childCreator);
        this.ev = ev;
        this.cc = childCreator;
        this.add(this.psp = new ParentSelectorPane(childCreator.getParentSelector()));
        ps = new JButton("change selector");
        ps.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                newPS();
            }
        });
        this.add(ps);
    }
    
    private void newPS() {
        String[] strings = new String[Evolution.getPopulationFunction().size()+1];
        int i = 0;
        for(Class c : Evolution.getParentSelectionFunction()){
            strings[i] = c.getCanonicalName();
            i++;
        }
        strings[i] = "add manually";
        String s = (String) JOptionPane.showInputDialog(this, 
            "What filter?",
            "add filter",
            JOptionPane.QUESTION_MESSAGE,
            null, 
            strings, 
            strings[0]);
        if(strings[i].equals(s))s = JOptionPane.showInputDialog("class to load (eg 'edu.ntnu.ef.evolution.Phenofilters.PopulationLimiter':");
        try {
            cc.setSelector((ParentSelector)ClassLoader.getSystemClassLoader().loadClass(s).newInstance());
            this.remove(this.psp);
            this.remove(ps);
            this.add(this.psp = new ParentSelectorPane(cc.getParentSelector()));
            this.add(ps);
            this.updateUI();
        } catch (InstantiationException ex) {
            Logger.getLogger(EvolutionPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(EvolutionPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(EvolutionPanel.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
}
