
package ev.ui;

import ev.Evolution;
import ev.Pheno;
import ev.PopulationFunction;
import ev.cc.ChildCreator;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.vecmath.Vector2d;
import swingplotter.Graph;
import swingplotter.PlotterPanel;

/**
 *
 * @author sigved
 */
public class EvolutionPanel extends JPanel{
    private Evolution model;
    private JList<PopulationFunction> functionList = new JList<PopulationFunction>();
    private final DefaultListModel<PopulationFunction> functionListModel;
    private JList<Pheno> phenoList = new JList<Pheno>();
    private final DefaultListModel<Pheno> phenoListModel;
    private PlotterPanel graphPane = new PlotterPanel();
    private JPanel detailPanel = new JPanel();
    private final JPanel buttonPanel;
    private Graph graphPopSize;
    private Graph graphBestFitness;
    private Graph graphMedianFitness;
    private Graph graphWorstFitnes;
    public EvolutionPanel(){
        detailPanel.add(new JButton("detailpanel"));
        graphPane.setPreferredSize(new Dimension(500, 500));
        graphPane.setScroll(true, false);
        graphPane.setPos(new Vector2d(-5.0d, 0.0d));
        graphPane.setScale(new Vector2d(0.1d, 0.001d));
        this.setLayout(new BorderLayout());
        JPanel right = new JPanel(new GridLayout(1, 2));
        
        buttonPanel = new JPanel();
        buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.Y_AXIS));
        
        JPanel temp = new JPanel(new BorderLayout());
        JPanel temp2 = new JPanel(new GridLayout(2, 1));
        temp2.add(new JScrollPane(phenoList));
        temp2.add(new JScrollPane(functionList));
        temp.add(temp2, BorderLayout.CENTER);
        temp.add(buttonPanel, BorderLayout.SOUTH);
        right.add(temp);
        
        right.add(detailPanel);
        this.add(right, BorderLayout.EAST);
        this.add(graphPane, BorderLayout.CENTER);
        this.functionListModel = new DefaultListModel<PopulationFunction>();
        functionList.setModel(functionListModel);
        functionList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        functionList.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent arg0) {
                selectedItem(functionList.getSelectedValue());
            }
        });
        
        phenoList.setModel(phenoListModel = new DefaultListModel<Pheno>());
        phenoList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        phenoList.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent evt) {
                JList list = (JList)evt.getSource();
                if (evt.getClickCount() == 2) {
                    int index = list.locationToIndex(evt.getPoint());
                    JFrame f = new JFrame(phenoList.getSelectedValue().toString());
                    f.add(new GenericPhenoPanel(phenoList.getSelectedValue()));
                    f.setLocation(evt.getLocationOnScreen());
                    f.pack();
                    f.setVisible(true);
                }
            }
        });
        addButtons();
    }
    private void addButtons() {
        JButton addButton = new JButton("add");
        addButton.setAlignmentX(CENTER_ALIGNMENT);
        JButton remButton = new JButton("remove");
        remButton.setAlignmentX(CENTER_ALIGNMENT);
        JButton mupButton = new JButton("move up");
        mupButton.setAlignmentX(CENTER_ALIGNMENT);
        JButton mdoButton = new JButton("move down");
        mdoButton.setAlignmentX(CENTER_ALIGNMENT);
        JButton evoButton = new JButton("evolve");
        evoButton.setAlignmentX(CENTER_ALIGNMENT);
        
        JButton evoMButton = new JButton("evolve*");
        evoMButton.setAlignmentX(CENTER_ALIGNMENT);
        buttonPanel.add(addButton);
        buttonPanel.add(remButton);
        buttonPanel.add(mupButton);
        buttonPanel.add(mdoButton);
        buttonPanel.add(evoButton);
        buttonPanel.add(evoMButton);
        addButton.addActionListener(new ActionListener() {@Override public void actionPerformed(ActionEvent arg0) {add();}});
        remButton.addActionListener(new ActionListener() {@Override public void actionPerformed(ActionEvent arg0) {rem();}});
        mupButton.addActionListener(new ActionListener() {@Override public void actionPerformed(ActionEvent arg0) {mup();}});
        mdoButton.addActionListener(new ActionListener() {@Override public void actionPerformed(ActionEvent arg0) {mdo();}});
        evoButton.addActionListener(new ActionListener() {@Override public void actionPerformed(ActionEvent arg0) {model.evolve();updateAll();}});
        evoMButton.addActionListener(new ActionListener() {@Override public void actionPerformed(ActionEvent arg0) {
            final int many = Integer.parseInt(JOptionPane.showInputDialog("many?"));
            new Thread(new Runnable() {

                    @Override
                    public void run() {
                        for(int i = 0; i < many; i++){
                            model.evolve();
                            updateAll();
                        }
                    }
                }).start();
            
        }});
    }
    protected void add(){
       String[] strings = new String[Evolution.getPopulationFunction().size()+1];
        int i = 0;
        for(Class c : Evolution.getPopulationFunction()){
            strings[i] = c.getCanonicalName();
            i++;
        }
        strings[i] = "add manually";
        String s = (String) JOptionPane.showInputDialog(this, 
            "What filter?",
            "add filter",
           JOptionPane.QUESTION_MESSAGE,
            null, 
            strings, 
            strings[0]);
        if(strings[i].equals(s))s = JOptionPane.showInputDialog("class to load (eg 'edu.ntnu.ef.evolution.Phenofilters.PopulationLimiter':");
        try {
                model.getFunctions().add(ClassLoader.getSystemClassLoader().loadClass(s).newInstance());
        } catch (InstantiationException ex) {
            Logger.getLogger(EvolutionPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(EvolutionPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(EvolutionPanel.class.getName()).log(Level.SEVERE, null, ex);
        }
        this.updateMenu();
    }
    protected void rem(){
        PopulationFunction pf = functionList.getSelectedValue();
        if(pf != null){
            model.getFunctions().remove(pf);
            this.updateMenu();
        }
    }
    protected void mup(){
        if(functionList.getSelectedIndex() > 0){
            List<PopulationFunction> list = model.getFunctions();
            System.out.println(list);
            int index = list.indexOf(functionList.getSelectedValue());
            PopulationFunction t = list.get(index-1);
            list.set(index-1, functionList.getSelectedValue());
            list.set(index, t);
            System.out.println(list);
            functionList.setSelectedIndex(index-1);
            updateMenu();
        }
    }
    protected void mdo(){
        if(functionList.getSelectedIndex() < functionListModel.getSize()-1){
            List<PopulationFunction> list = model.getFunctions();
            System.out.println(list);
            int index = list.indexOf(functionList.getSelectedValue());
            PopulationFunction t = list.get(index+1);
            list.set(index+1, functionList.getSelectedValue());
            list.set(index, t);
            System.out.println(list);
            functionList.setSelectedIndex(index+1);
            updateMenu();
        }
    }
    int stage = 0;
    public void setModel(Evolution e){
        this.model = e;
        this.stage = 0;
        ArrayList<Graph> graphs = new ArrayList<Graph>();
        graphs.add(this.graphPopSize = new Graph(Color.blue));
        graphs.add(this.graphBestFitness = new Graph(Color.yellow));
        graphs.add(this.graphMedianFitness = new Graph(Color.red));
        graphs.add(this.graphWorstFitnes = new Graph(Color.black));
        graphPane.setGraphs(graphs);
        this.updateAll();
    }

    private void updateAll() {
        updateGraph();
        updateMenu();
        
        
    }

    private void updateGraph() {
        this.graphPopSize.addPoint(stage, this.model.getPopulationSize());
        this.graphBestFitness.addPoint(stage, this.model.getBestFitness());
        this.graphMedianFitness.addPoint(stage, this.model.getMedianFitness());
        this.graphWorstFitnes.addPoint(stage, this.model.getWorstFitness());
        this.graphPane.updateUI();
        stage++;
    }

    private void updateMenu() {
        SwingUtilities.invokeLater(new Runnable() {

            @Override
            public void run() {
                int selectedItem = functionList.getSelectedIndex();
                functionListModel.removeAllElements();
                List<PopulationFunction> l = model.getFunctions();
                for(PopulationFunction pf :  l){
                    functionListModel.addElement(pf);
                }
                functionList.setSelectedIndex(selectedItem);

                selectedItem = phenoList.getSelectedIndex();
                phenoListModel.removeAllElements();
                TreeSet<Pheno> phenoTree = new TreeSet<Pheno>(new Comparator<Pheno>(){

                    @Override
                    public int compare(Pheno arg0, Pheno arg1) {
                        if(arg0.getFitness() > arg1.getFitness())return 1;
                        else return -1;
                    }
                    
                });
                phenoTree.addAll(model.getPop());
                for(Pheno p : phenoTree.descendingSet()){
                    phenoListModel.addElement(p);
                }
                phenoList.setSelectedIndex(selectedItem);
            }
        });

    }
    private void selectedItem(PopulationFunction pf){
        if(pf == null)return;
        System.out.println("selected " + pf);
        detailPanel.removeAll();
        if(pf instanceof ChildCreator){
            detailPanel.add(new ChildCreatorPanel((ChildCreator)pf, model));
        }else detailPanel.add(new GenericFunctionPanel(pf));
        detailPanel.updateUI();
    }

}
