
package ev.ui;

import ev.Pheno;
import java.awt.BorderLayout;
import java.lang.reflect.Field;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

/**
 *
 * @author sigved
 */
class GenericPhenoPanel extends JPanel{
    public GenericPhenoPanel(final Pheno p) {
                this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.add(new JLabel(p.getClass().getName()));
        for(final Field f : p.getClass().getFields()){
            JPanel field = new JPanel(new BorderLayout());
            field.add(new JLabel(f.getName()), BorderLayout.WEST);
            this.add(field);
            if(f.getType().equals(double.class)){
                try {
                    final JTextField jtf = new JTextField("" + f.getDouble(p));
                    field.add(jtf);
                    jtf.getDocument().addDocumentListener(new DocumentListener() {
                        @Override
                        public void insertUpdate(DocumentEvent arg0) {
                            try {
                                f.set(p, Double.parseDouble(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        @Override
                        public void removeUpdate(DocumentEvent arg0) {
                            try {
                                f.set(p, Double.parseDouble(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        @Override
                        public void changedUpdate(DocumentEvent arg0) {
                            try {
                                f.set(p, Double.parseDouble(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                    });
                } catch (IllegalArgumentException ex) {
                    Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IllegalAccessException ex) {
                    Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                }
            }else if(f.getType().equals(int.class)){
                try {
                    final JTextField jtf = new JTextField("" + f.getInt(p));
                    field.add(jtf);
                    jtf.getDocument().addDocumentListener(new DocumentListener() {
                        @Override
                        public void insertUpdate(DocumentEvent arg0) {
                            try {
                                f.set(p, Integer.parseInt(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        @Override
                        public void removeUpdate(DocumentEvent arg0) {
                            try {
                                f.set(p, Integer.parseInt(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        @Override
                        public void changedUpdate(DocumentEvent arg0) {
                            try {
                                f.set(p, Integer.parseInt(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                    });
                } catch (IllegalArgumentException ex) {
                    Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IllegalAccessException ex) {
                    Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }
    
}
