
package ev.ui;

import ev.cc.ParentSelector;
import java.awt.BorderLayout;
import java.lang.reflect.Field;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

/**
 *
 * @author sigved
 */
class ParentSelectorPane extends JPanel{

    public ParentSelectorPane(final ParentSelector ps) {
        this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.add(new JLabel("parent selector"));
        if(ps == null)return;
        this.add(new JLabel(ps.getClass().getName()));
        for(final Field f : ps.getClass().getFields()){
            JPanel field = new JPanel(new BorderLayout());
            field.add(new JLabel(f.getName()), BorderLayout.WEST);
            this.add(field);
            if(f.getType().equals(double.class)){
                try {
                    final JTextField jtf = new JTextField("" + f.getDouble(ps));
                    field.add(jtf);
                    jtf.getDocument().addDocumentListener(new DocumentListener() {
                        @Override
                        public void insertUpdate(DocumentEvent arg0) {
                            try {
                                f.set(ps, Double.parseDouble(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        @Override
                        public void removeUpdate(DocumentEvent arg0) {
                            try {
                                f.set(ps, Double.parseDouble(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        @Override
                        public void changedUpdate(DocumentEvent arg0) {
                            try {
                                f.set(ps, Double.parseDouble(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                    });
                } catch (IllegalArgumentException ex) {
                    Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IllegalAccessException ex) {
                    Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                }
            }else if(f.getType().equals(int.class)){
                try {
                    final JTextField jtf = new JTextField("" + f.getInt(ps));
                    field.add(jtf);
                    jtf.getDocument().addDocumentListener(new DocumentListener() {
                        @Override
                        public void insertUpdate(DocumentEvent arg0) {
                            try {
                                f.set(ps, Integer.parseInt(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        @Override
                        public void removeUpdate(DocumentEvent arg0) {
                            try {
                                f.set(ps, Integer.parseInt(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        @Override
                        public void changedUpdate(DocumentEvent arg0) {
                            try {
                                f.set(ps, Integer.parseInt(jtf.getText()));
                            } catch (IllegalArgumentException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            } catch (IllegalAccessException ex) {
                                Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                    });
                } catch (IllegalArgumentException ex) {
                    Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IllegalAccessException ex) {
                    Logger.getLogger(GenericFunctionPanel.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }
    
}
