
package fs;

import java.io.IOException;
import java.util.HashSet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.eclipse.jetty.server.Request;
import org.eclipse.jetty.server.handler.AbstractHandler;
import org.reflections.Reflections;
import weka.classifiers.Classifier;

/**
 *
 * @author sigved
 */
public class Classifiers extends HashSet<Class<? extends Classifier>>{
    public void addFromPackage(String packageName){
        Reflections ref = new Reflections(packageName);
        for(Class<? extends Classifier> c : ref.getSubTypesOf(Classifier.class)){
            this.add(c);
        }
    }
    public class ClassifiersHandler extends AbstractHandler{
        HttpServletResponse res;
        @Override
        public void handle(String string, Request rqst, HttpServletRequest hsr, HttpServletResponse res) throws IOException{
            this.res = res;
            res.setContentType("text/html");
            res.setStatus(HttpServletResponse.SC_OK);
            rqst.setHandled(true);
            for(String k : rqst.getParameterMap().keySet()){
                System.out.print(k + ": ");
                for(String v : rqst.getParameterMap().get(k))System.out.print(k + " ");
                System.out.println("");
            }
        }
        
        public void print(String s) throws IOException{
            res.getWriter().println(s);
        }
    }
}
