/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fs;

import java.awt.image.Kernel;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import weka.classifiers.Classifier;
import weka.classifiers.Evaluation;
import weka.classifiers.bayes.NaiveBayes;
import weka.classifiers.functions.SMO;
import weka.classifiers.functions.supportVector.RBFKernel;
import weka.classifiers.lazy.IB1;
import weka.classifiers.lazy.IBk;
import weka.classifiers.trees.J48;
import weka.core.Instances;

/**
 *
 * @author sigved
 */
public class CrossVal {
    public double std = 0;
    public double mean = 0;
    public double indexesMean = 0;
    public double indexesStd = 0;
    public double fitnessMean = 0;
    public double fitnessStd = 0;
    ArrayList<Double> fitnessList = new ArrayList<Double>();
    ArrayList<Set<Integer>> indexSet = new ArrayList<Set<Integer>>();
    public static CrossVal crossval(Class<? extends Classifier> cc, String[] options, int numfolds, Instances testdata) throws Exception{
        CrossVal ret = new CrossVal();
        double[] errors = new double[numfolds];
        double[] indexes = new double[numfolds];
        for(int i = 0; i < numfolds; i++){
            Evaluation eval = new Evaluation(testdata);
            Instances train = testdata.trainCV(numfolds, i);
            Instances test = testdata.testCV(numfolds, i);
            Classifier clsc = cc.newInstance();
            
            //remove pruning etc
            {
                if(clsc instanceof J48){
                    ((J48)clsc).setUnpruned(true);
                }
                if(clsc instanceof IB1){
                    
                }
                if(clsc instanceof IBk){
                    ((IBk)clsc).setMeanSquared(false);
                    ((IBk)clsc).setKNN(5);
                }
                if(clsc instanceof NaiveBayes){

                }
                if(clsc instanceof SMO){
                    
                }
            }
            
            clsc.setOptions(options);
            clsc.buildClassifier(train);
            eval.evaluateModel(clsc, test);
            double err = eval.errorRate();
            errors[i] = err;
            ret.mean += err/(double)numfolds;
            if(clsc instanceof EVFS){
                indexes[i] = ((EVFS)clsc).indexes.size()-1;
                Set<Integer> ns = new HashSet<Integer>(((EVFS)clsc).indexes);
                ns.remove(testdata.classIndex());
                ret.indexSet.add(ns);
                ret.indexesMean += indexes[i]/(double)numfolds;
                ret.fitnessList.add(((EVFS)clsc).fit);
                ret.fitnessMean += ((EVFS)clsc).fit/(double)numfolds;
            }
//            System.out.println(mean);
        }
        double top = 0d;
        for(double e : errors)top += (e-ret.mean)*(e-ret.mean);
        ret.std = Math.sqrt(top/(double)numfolds);
        
        top = 0;
        for(double i : indexes)top += (i-ret.indexesMean)*(i-ret.indexesMean);
        ret.indexesStd = Math.sqrt(top/(double)numfolds);
        
        top = 0;
        for(double i : ret.fitnessList)top += (i-ret.fitnessMean)*(i-ret.fitnessMean);
        ret.fitnessStd = Math.sqrt(top/(double)numfolds);
        
        return ret;
    }
    
    public double tamimotoDistanceAverage(){
        return tamimotoDistanceAverage(indexSet);
    }
    public static double tamimotoDistanceAverage(List<Set<Integer>> ss){
        ArrayList<Set<Integer>> setList = new ArrayList<Set<Integer>>(ss);
        double n = 0;
        double tot = 0;
        for(int i = 0; i < setList.size(); i++){
            for(int j = i+1; j < setList.size(); j++){
                n++;
                tot += tamimotoDistance(setList.get(i),setList.get(j));
            }
        }
        return 1.0d-tot/n;
    }
    
    /**
     * the tamimoto distance of two sets, a metric of how much overlap there is, 1.0 = complete overlap, 0.0 = no overlap
     * @param a set
     * @param b set
     * @return tamimoto distance
     */
    private static double tamimotoDistance(Set<Integer> a, Set<Integer> b){
        double snitt = 0;
        for(int i : a){
            if(b.contains(i)){
                snitt++;
            }
        }
        double top = a.size() + b.size() - (2.0d * snitt);
        double bot = a.size() + b.size() - snitt;
        
        return 1.0d - (top/bot);
    }
}
