/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package fs;

import ev.Evolution;
import ev.cc.ChildCreator;
import ev.cc.parentSelectors.TournamentSelector;
import ev.popfunc.AgeAdder;
import ev.popfunc.PopulationLimit;
import ev.ui.servlet.EVServer;
import fs.data.DataWrapperAS;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.logging.Level;
import java.util.logging.Logger;
import weka.classifiers.Classifier;
import weka.classifiers.lazy.IBk;
import weka.core.Instance;
import weka.core.Instances;

/**
 *
 * @author sigved
 */
public class EVFS  extends Classifier{
    public int seed = 0;
    Classifier classifier = new IBk();//the wrapper induction algorithm used
    int ps = 400;//number of new individuals created each iterationT2
    int iters = 1000;//maximum number of iterationsT2
    int elitism = 1;//number of elite spots in the population
    int numfolds = 10;//number of folds in the crossover validation in the fitness function
    int np = 2;//number of parents when using crossover
    int gs = 4;//parent selection tournament size
    double crosschance = 0.4;//cross-over rate
    double rc = 0.2d;//random chance
    double stopAt = 1.5d;//stop a little after reaching this accuracy with the best individual
    double lp = 0.0000000000001;//length penalty used in fitness evaluation
    double mr = 0.7;//mutation rate
    public HashSet<Integer> indexes;
    private Instances holder;
    public boolean servlet = false;//use servlet, usefull for debugging
    public WrapperFitness ff;
    double fit = 0;//fitness of final solution
    int initpop = 3;//initial population
    public double stopCV = -1f;//value for benchmarking
    
    @Override
    public void buildClassifier(Instances i) throws Exception {
        holder = new Instances(i);
        ArrayList<Class<? extends Classifier>> classifiers = new ArrayList<Class<? extends Classifier>>();
        classifiers.add(classifier.getClass());
        Evolution<FeatureSet,FeatureSet> e = FeatureSet.createFeaturePopulation(seed, ps, classifiers, i.numAttributes()-1, true);
        DataWrapperAS dw = new DataWrapperAS(i);
        ff = new WrapperFitness(dw);
        ff.nf = numfolds;
        ff.lp = lp;
        FeatureSet.initiatePopulation(initpop, e.getPop(), seed+1, ff);
        e.getFunctions().add(new AgeAdder());
        ChildCreator cc = new ChildCreator();
        cc.mutationRate = mr;
        cc.numberOfChildren = ps;
        cc.numberOfParents = np;
        cc.crosschance = crosschance;
        TournamentSelector ts = new TournamentSelector();
        ts.groupSize = gs;
        ts.randomChance = rc;
        cc.setSelector(ts);
        e.getFunctions().add(cc);
        
        PopulationLimit pl = new PopulationLimit();
        pl.limit = elitism;
        pl.maxAge = 1000000000;
        pl.minAge = 0;
        
        e.getFunctions().add(pl);
        e.getFunctions().add(ff);
        e.getFunctions().add(pl);
        if(servlet){
            EVServer server = new FSServer(1337, e, dw);
            server.run();
        }
        int count = 0;
        while(count < iters){
            System.out.print(count+ ", fitness: " + e.getBestFitness() +"                        \r");
            e.evolve();
            count++;
            if(e.getBestFitness() >= (stopAt-lp*e.getBestPheno().indexes.size()) && count + 0 < iters){
                count = iters;// - 10;
            }
        }
        
        FeatureSet fs = (FeatureSet) e.getBestPheno();
        fit = fs.getFitness();
        stopCV = fit+lp*fs.indexes.size();
        this.indexes = new HashSet<Integer>();
        for(int index : fs.indexes){
            if(index < dw.getClassIndex())indexes.add(index);
            else indexes.add(index+1);
        }
        this.indexes.add(dw.getClassIndex());
        System.out.println(indexes + ", " + stopCV + fs.indexes + " + " + dw.getClassIndex());
        classifier.buildClassifier(dw.getFeatureSubSet(this.indexes).getAll());
    }
    
    @Override
    public double classifyInstance(Instance i) throws Exception{
        holder.add(i);
        
        DataWrapperAS dw = new DataWrapperAS(holder);
        double ret = this.classifier.classifyInstance(dw.getFeatureSubSet(this.indexes).getAll().lastInstance());
        return ret;
    }
    @Override
    public void setOptions(String[] options) {
        for(int i = 0; i < options.length; i++){
            if(options[i].equals("-lp")){
                i++;
                this.lp = Double.parseDouble(options[i]);
            }
            if(options[i].equals("-iters")){
                i++;
                this.iters = Integer.parseInt(options[i]);
            }
            if(options[i].equals("-w")){
                try {
                    i++;
                    Class<?> cls = Class.forName(options[i]);
                    this.classifier = (Classifier) cls.newInstance();
                } catch (ClassNotFoundException ex) {
                    Logger.getLogger(EVFS.class.getName()).log(Level.SEVERE, null, ex);
                } catch (InstantiationException ex) {
                    Logger.getLogger(EVFS.class.getName()).log(Level.SEVERE, null, ex);
                } catch (IllegalAccessException ex) {
                    Logger.getLogger(EVFS.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }
    }
    
}
