
package fs;

import ev.Evolution;
import ev.ui.servlet.EVServer;
import fs.data.DataWrapperAS;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.eclipse.jetty.server.Request;
import org.eclipse.jetty.server.handler.AbstractHandler;
import org.eclipse.jetty.server.handler.ContextHandler;
import swingplotter.Graph;

/**
 *
 * @author sigved
 */
public class FSServer extends EVServer{
    private final Graph validationGraph;
    private final DataWrapperAS dw;
    public FSServer(int port, Evolution ev, DataWrapperAS dw) throws Exception{
        super(port, ev);
        this.dw = dw;
        this.graphPane.addGraph(this.validationGraph = new Graph(Color.GREEN));
        ContextHandler chpv = new ContextHandler("/populationview");
        chpv.setHandler(new PopulationViewHandler());
        hcc.addHandler(chpv);
        restart();
    }
    private class PopulationViewHandler extends AbstractHandler{
        @Override
        public void handle(String string, Request rqst, HttpServletRequest hsr, HttpServletResponse res) throws ServletException {
            res.setContentType("image/jpeg");
            res.setStatus(HttpServletResponse.SC_OK);
            rqst.setHandled(true);
            try{
                BufferedImage bufferedImage = new BufferedImage(800, 800, BufferedImage.TYPE_BYTE_BINARY);
                Graphics g = bufferedImage.getGraphics();
                PopulationView graphPane = new PopulationView(ts);
                graphPane.setSize(500, 500);
                synchronized(graphPane){graphPane.paint(g);}
                g.dispose();
                //Write the image as a jpg
                ImageIO.write(bufferedImage, "bmp", res.getOutputStream());
            }catch (IOException ioe){}
        }
    }
    @Override
    public void runGraphs() throws FileNotFoundException{
        try {
//            this.validationGraph.addPoint(i, 1.0-Test.testFeatureSet((FeatureSet)ev.getBestPheno(), dw));
        } catch (Exception ex) {
            Logger.getLogger(FSServer.class.getName()).log(Level.SEVERE, null, ex);
        }
        super.runGraphs();
    }
}
